#-------------------------------------------------------------------------------
# Internal Functions
#-------------------------------------------------------------------------------

#-------------------------------------------------------------------------------
# Convert Array to Long format
#-------------------------------------------------------------------------------
.formatLong <- function(x, na.rm=F)
{
  .out <- expand.grid(dimnames(x))
  names(.out) <- c("origin", "dev", "triangle")
  .out$data <- as.vector(x)

  if(na.rm==T) .out <- .out[!is.na(.out$data), ]

  return(.out)
}


#-------------------------------------------------------------------------------
# Expand a single dimension of an array (repeats existing data)
#-------------------------------------------------------------------------------
.expandArray <- function(x, d, new.size)
{
  # Expand array x, in d th dimension to new.size

  # Permute dimension to set changing dimension last
  .n <- length(dim(x))
  .perm <- 1:.n
  .perm[d] <- .n
  .perm[.n] <- d
  x <- aperm(x, .perm)

  # Expand dimension
  x <- array(x, dim=c(dim(x)[-.n], new.size))

  #Return to old dimension arrangement
  x <- aperm(x, .perm)

  return(x)

}

