
# Return triangle of cumulative claims
makeCumulative <- function(x)
{
  UseMethod("makeCumulative")
}

# Return triangle of cumulative claims
makeIncremental <- function(x)
{
  UseMethod("makeIncremental")
}

# Return latest claims data
getLatest <- function(x, drop=F)
{
  UseMethod("getLatest")
}

# Return individual development factors
.getIndivDFs <- function(x)
{
  UseMethod(".getIndivDFs")
}


# ******************************************************************************
# General Functions
# ******************************************************************************




#-------------------------------------------------------------------------------
# Residuals
#-------------------------------------------------------------------------------

calculateResiduals <- function(projection)
{
  if(!("Projection" %in% class(projection)))
    stop("Need object of class: Projection")

  .resids <- makeIncremental(projection$data)
  .resids$data <- (.resids$data - projection$exp$data) /
    (projection$exp$data ^0.5)
    
  return(.resids)

}

plotResiduals <- function(projection, triangle=1, ...)
{
  if(!("Projection" %in% class(projection)))
    stop("Need object of class: Projection")

  # Convert Triangle of DFs to Long format
  .resids <- calculateResiduals(projection)
  .resids <- .formatLong(.resids$data, na.rm=T)
  .resids <- .resids[.resids$triangle==triangle, ]

  # Careful as factors - MAY NEED TO REVISIT !!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
  .x <- as.numeric(.resids$dev)
  plot(.x, .resids$data, pch="x", cex=0.8,
    xlab="Develpoment Period", ylab="Pearson Residual",
    main="Plot of Residuals", ...)
    
  abline(h=0)
}







# ******************************************************************************


# Sample data for testing
Mack <- read.csv("C:/Documents and Settings/desilvan/My Documents/Working Party/R/Mack 2.csv", header=F)
#Mack <- read.csv("F:/Nigel's Documents/Working Party/R Examples/Mack 2.csv", header=F)
Mack <- as.matrix(Mack)
Mack <- array(Mack, dim=c(dim(Mack),2))

Mack <- ArrayTriangle(Mack, cumulative=F)

plot(calculateUltDFs(Mack), 2)

CL <- ChainLadder(Mack)

plotResiduals(CL)
